ServerEvents.recipes(event => {
  event.shaped(
    Item.of('cbcmodernwarfare:era_block', 4),
    [
      'HHH',
      'NNN',
      'HHH'
    ],
    {
      H: 'tfmg:heavy_plate',
      N: 'createbigcannons:congealed_nitro'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:tan_era_block', 8),
    [
      'EEE',
      'EDE',
      'EEE'
    ],
    {
      E: 'cbcmodernwarfare:era_block',
      D: '#forge:dyes/yellow'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:green_era_block', 8),
    [
      'EEE',
      'EDE',
      'EEE'
    ],
    {
      E: 'cbcmodernwarfare:era_block',
      D: '#forge:dyes/green'
    }
  );



  event.shaped(
    Item.of('cbcmodernwarfare:incomplete_steel_mediumcannon_recoil_barrel'),
    [
      'SAS',
      'SPS',
      'SAS'
    ],
    {
      S: '#forge:ingots/steel',
      A: 'minecraft:air',
      P: 'tfmg:heavy_plate'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:steel_mediumcannon_barrel'),
    [
      'SAS',
      'SAS',
      'SAS'
    ],
    {
      S: '#forge:ingots/steel',
      A: 'minecraft:air'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:incomplete_steel_mediumcannon_breech'),
    [
      'SPS',
      'SAS',
      'SPS'
    ],
    {
      S: '#forge:ingots/steel',
      A: 'minecraft:air',
      P: 'tfmg:heavy_plate'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:steel_mediumcannon_falling_breech'),
    [
      'CSC',
      'ASA'
    ],
    {
      S: '#forge:ingots/steel',
      A: 'minecraft:air',
      C: 'steampowered:steel_cogwheel'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:he_mediumcannon_round'),
    [
      'AIA',
      'ICI',
      'ASA'
    ],
    {
      S: '#minecraft:wooden_slabs',
      A: 'minecraft:air',
      C: 'createbigcannons:packed_guncotton',
      I: 'minecraft:iron_ingot'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:he_mediumcannon_cartridge', {'Projectile': {'id': 'cbcmodernwarfare:he_mediumcannon_round', 'Count': 1}}),
    [
      'R',
      'C'
    ],
    {
      R: 'cbcmodernwarfare:he_mediumcannon_round',
      C: 'cbcmodernwarfare:filled_mediumcannon_cartridge'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:filled_mediumcannon_cartridge'),
    [
      'N',
      'C'
    ],
    {
      N: 'createbigcannons:nitropowder',
      C: 'cbcmodernwarfare:empty_mediumcannon_cartridge'
    }
  );
  event.shaped(
    Item.of('cbcmodernwarfare:compact_mount'),
    [
      'SCS',
      'AGA'
    ],
    {
      A: 'minecraft:air',
      S: 'create:shaft',
      C: 'create:andesite_casing',
      G: 'minecraft:gunpowder'
    }
  );


  event.recipes.create.deploying('cbcmodernwarfare:heavy_recoil_spring', ['createbigcannons:recoil_spring', 'tfmg:heavy_plate']);
  event.recipes.create.pressing('cbcmodernwarfare:empty_mediumcannon_cartridge', 'cbcmodernwarfare:mediumcannon_cartridge_sheet');
  event.recipes.create.cutting(Item.of('cbcmodernwarfare:mediumcannon_cartridge_sheet', 2), 'createbigcannons:big_cartridge_sheet').processingTime(200);
  event.recipes.create.mixing(Fluid.of('tfmg:molten_slag', 144), Item.of('molten_metals:slag')).heated();
  event.recipes.create.mixing(Fluid.of('tfmg:molten_slag', 1296), Item.of('molten_metals:slag_block')).heated();
});